diff --git a/src/main/java/net/minecraft/client/gui/GuiCreateWorld.java b/src/main/java/net/minecraft/client/gui/GuiCreateWorld.java
index ebb29ce57..d247c645f 100644
--- a/src/main/java/net/minecraft/client/gui/GuiCreateWorld.java
+++ b/src/main/java/net/minecraft/client/gui/GuiCreateWorld.java
@@ -1,84 +1,55 @@
 package net.minecraft.client.gui;
 
-import java.util.ArrayList;
-import java.util.Arrays;
-import java.util.List;
-import java.util.Random;
-
 import net.minecraft.client.gui.popup.GuiPopup;
 import net.minecraft.client.gui.popup.PopupBuilder;
+import net.minecraft.client.player.controller.PlayerControllerSP;
 import net.minecraft.core.data.registry.Registries;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.util.helper.ChatAllowedCharacters;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.lang.I18n;
-import net.minecraft.client.player.controller.PlayerControllerSP;
-import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.world.Dimension;
-import net.minecraft.core.world.type.WorldType;
-import net.minecraft.core.world.type.WorldTypes;
 import net.minecraft.core.world.save.ISaveFormat;
+import net.minecraft.core.world.type.WorldTypeGroups;
 import org.lwjgl.input.Keyboard;
 
-public class GuiCreateWorld extends GuiScreen
-{
+import java.util.List;
+import java.util.Random;
+
+public class GuiCreateWorld extends GuiScreen {
     private int overrideSpawnX;
     private int overrideSpawnY;
     private int overrideSpawnZ;
-    private GuiScreen field_22131_a;
+    private GuiScreen textField;
     private GuiTextField textboxWorldName;
     private GuiTextField textboxSeed;
     private GuiButton createWorldButton;
     private GuiButton gamemodeButton;
     private GuiButton cheatsButton;
     private GuiButton worldTypeButton;
-    private GuiTexturedButton buttonRandomWorldName;
-    private GuiTexturedButton buttonRandomSeed;
+    private GuiButton buttonRandomWorldName;
+    private GuiButton buttonRandomSeed;
     private String folderName;
     private boolean createClicked;
     private Gamemode selectedGamemode = Gamemode.survival;
     private boolean cheatsEnabled = false;
-    private int worldType = 0;
-    private final List<WorldType> worldTypes;
+    private WorldTypeGroups.Group worldTypeGroup = WorldTypeGroups.DEFAULT;
     private long seed = (new Random()).nextLong();
 
-    public GuiCreateWorld(GuiScreen guiscreen)
-    {
-        field_22131_a = guiscreen;
-
-        // Initialize world types
-        worldTypes = new ArrayList<>();
-        worldTypes.addAll(Arrays.asList(
-            WorldTypes.OVERWORLD_EXTENDED, WorldTypes.OVERWORLD_DEFAULT, WorldTypes.OVERWORLD_WINTER,
-            WorldTypes.OVERWORLD_FLOATING, WorldTypes.OVERWORLD_AMPLIFIED, WorldTypes.OVERWORLD_ISLANDS,
-            WorldTypes.OVERWORLD_INLAND, WorldTypes.FLAT, WorldTypes.OVERWORLD_HELL, WorldTypes.OVERWORLD_WOODS,
-            WorldTypes.OVERWORLD_PARADISE, WorldTypes.OVERWORLD_CLASSIC, WorldTypes.OVERWORLD_INDEV, WorldTypes.OVERWORLD_RETRO,
-            WorldTypes.EMPTY, WorldTypes.DEBUG
-        ));
-
-        for (WorldType worldType : Registries.WORLD_TYPES)
-        {
-            if (!worldTypes.contains(worldType))
-            {
-                worldTypes.add(worldType);
-            }
-        }
-
-        worldTypes.remove(WorldTypes.NETHER_DEFAULT);
-        worldTypes.remove(WorldTypes.PARADISE_DEFAULT);
+    public GuiCreateWorld(GuiScreen guiscreen) {
+        textField = guiscreen;
     }
 
     @Override
-	public void tick()
-    {
+    public void tick() {
         textboxWorldName.updateCursorCounter();
         textboxSeed.updateCursorCounter();
     }
 
     @Override
-	public void init()
-    {
+    public void init() {
         I18n i18n = I18n.getInstance();
         Keyboard.enableRepeatEvents(true);
         controlList.clear();
@@ -93,142 +64,116 @@ public class GuiCreateWorld extends GuiScreen
         controlList.add(gamemodeButton = new GuiButton(2, width / 2 - 100, 100 + 20 + 4, 98, 20, ""));
         controlList.add(cheatsButton = new GuiButton(3, width / 2 - 100 + 102, 100 + 20 + 4, 98, 20, ""));
         controlList.add(worldTypeButton = new GuiButton(4, width / 2 - 100, 100 + 20 + 20 + 4 + 4, ""));
-        controlList.add(buttonRandomWorldName = new GuiTexturedButton(5, "/assets/minecraft/textures/gui/gui.png", width / 2 + 100 - 20, 60, 60, 86, 20, 20));
-        controlList.add(buttonRandomSeed = new GuiTexturedButton(6, "/assets/minecraft/textures/gui/gui.png", width / 2 + 100 - 20, 100, 60, 86, 20, 20));
+        controlList.add(buttonRandomWorldName = new GuiButton(5, width / 2 + 100 - 20, 60, 20, 20, "")
+            .setTextures("minecraft:gui/misc/button_random", "minecraft:gui/misc/button_random_highlighted", "minecraft:gui/misc/button_random"));
+        controlList.add(buttonRandomSeed = new GuiButton(6, width / 2 + 100 - 20, 100, 20, 20, "")
+            .setTextures("minecraft:gui/misc/button_random", "minecraft:gui/misc/button_random_highlighted", "minecraft:gui/misc/button_random"));
         updateButtons();
         updateFolderName();
     }
 
-    private void updateFolderName()
-    {
+    private void updateFolderName() {
         folderName = textboxWorldName.getText().trim();
         char[] ac = ChatAllowedCharacters.ALLOWED_CHARACTERS_ARRAY;
         for (char c : ac) {
             folderName = folderName.replace(c, '_');
         }
 
-        if(MathHelper.stringNullOrLengthZero(folderName))
-        {
+        if (MathHelper.stringNullOrLengthZero(folderName)) {
             folderName = "New World";
         }
         folderName = generateUnusedFolderName(mc.getSaveFormat(), folderName);
     }
 
-    public static String generateUnusedFolderName(ISaveFormat isaveformat, String s)
-    {
+    public static String generateUnusedFolderName(ISaveFormat isaveformat, String s) {
         int count = 1;
         String newString = s;
-        for(; isaveformat.getLevelData(newString) != null; count++){
+        for (; isaveformat.getLevelData(newString) != null; count++) {
             newString = s + " (" + count + ")";
         }
         return newString;
     }
 
     @Override
-	public void onClosed()
-    {
+    public void onClosed() {
         Keyboard.enableRepeatEvents(false);
     }
 
     @Override
-	protected void buttonPressed(GuiButton button)
-    {
-        if(!button.enabled)
-        {
+    protected void buttonPressed(GuiButton button) {
+        if (!button.enabled) {
             return;
         }
-        if(button.id == 1)
-        {
-            mc.displayGuiScreen(field_22131_a);
-        } else
-        if(button.id == 0)
-        {
+        if (button.id == 1) {
+            mc.displayGuiScreen(textField);
+        } else if (button.id == 0) {
             mc.displayGuiScreen(null);
-            if(createClicked)
-            {
+            if (createClicked) {
                 return;
             }
             createClicked = true;
             long seed = this.seed;
             String seedText = textboxSeed.getText();
-            if(!MathHelper.stringNullOrLengthZero(seedText))
-            {
-                try
-                {
+            if (!MathHelper.stringNullOrLengthZero(seedText)) {
+                try {
                     long parsedSeed = Long.parseLong(seedText);
-                    if(parsedSeed != 0L)
-                    {
+                    if (parsedSeed != 0L) {
                         seed = parsedSeed;
                     }
-                }
-                catch(NumberFormatException e)
-                {
+                } catch (NumberFormatException e) {
                     seed = seedText.hashCode();
                 }
             }
-            Dimension.overworld.setDefaultWorldType(worldTypes.get(worldType));
             mc.playerController = new PlayerControllerSP(mc);
             String worldName = textboxWorldName.getText();
             if (worldName.isEmpty()) {
                 worldName = I18n.getInstance().translateKey("gui.create_world.label.new_world");
             }
-            mc.startWorld(folderName, worldName, seed);
+            mc.startWorld(folderName, worldName, seed, worldTypeGroup);
             mc.thePlayer.setGamemode(selectedGamemode);
-            if (selectedGamemode == Gamemode.adventure){
-                mc.thePlayer.inventory.insertItem(Item.toolAxeWood.getDefaultStack(), true);
+            if (selectedGamemode == Gamemode.adventure) {
+                mc.thePlayer.inventory.insertItem(Items.TOOL_AXE_WOOD.getDefaultStack(), true);
             }
             if (mc.worldPresetName != null) mc.thePlayer.setPos(overrideSpawnX, overrideSpawnY, overrideSpawnZ);
             mc.theWorld.getLevelData().setCheatsEnabled(cheatsEnabled);
             mc.displayGuiScreen(null);
-        }
-        else if (button == gamemodeButton)
-        {
+        } else if (button == gamemodeButton) {
             I18n i18n = I18n.getInstance();
             List<Gamemode> gamemodeList = Gamemode.getPublicGamemodes();
             selectedGamemode = gamemodeList.get((gamemodeList.indexOf(selectedGamemode) + 1) % gamemodeList.size());
-        	cheatsEnabled = selectedGamemode == Gamemode.creative;
+            cheatsEnabled = selectedGamemode == Gamemode.creative;
             updateButtons();
-        }
-        else if (button == cheatsButton)
-        {
-        	I18n i18n = I18n.getInstance();
-        	cheatsEnabled = !cheatsEnabled;
+        } else if (button == cheatsButton) {
+            I18n i18n = I18n.getInstance();
+            cheatsEnabled = !cheatsEnabled;
             updateButtons();
-        }
-        else if (button == worldTypeButton)
-        {
+        } else if (button == worldTypeButton) {
             I18n i18n = I18n.getInstance();
-            String[] keys = new String[worldTypes.size()];
-            String[] descs = new String[worldTypes.size()];
-            for (int i = 0; i < keys.length; i++)
-            {
-                keys[i] = i18n.translateKey(worldTypes.get(i).getLanguageKey() + ".name");
-                descs[i] = i18n.translateKey(worldTypes.get(i).getLanguageKey() + ".desc") + "\n" +
-                    TextFormatting.GRAY + Registries.WORLD_TYPES.getKey(worldTypes.get(i));
+            String[] keys = new String[WorldTypeGroups.GROUPS.size()];
+            String[] descs = new String[WorldTypeGroups.GROUPS.size()];
+            for (int i = 0; i < keys.length; i++) {
+                keys[i] = i18n.translateKey(WorldTypeGroups.GROUPS.get(i).get(Dimension.overworld).getLanguageKey() + ".name");
+                descs[i] = i18n.translateKey(WorldTypeGroups.GROUPS.get(i).get(Dimension.overworld).getLanguageKey() + ".desc") + "\n" +
+                    TextFormatting.GRAY + Registries.WORLD_TYPES.getKey(WorldTypeGroups.GROUPS.get(i).get(Dimension.overworld));
             }
 
             GuiPopup popup = new PopupBuilder(this, 150)
-                    .closeOnEsc(0)
-                    .closeOnClickOut(0)
-                    .withLabel("gui.create_world.label.select_world_type")
-                    .withList("worldTypeList", 140, keys, descs, worldType, true)
-                    .withOnCloseListener((statusCode, results) -> {
-                        if (statusCode == 1)
-                        {
-                            worldType = (Integer) results.get("worldTypeList");
-                            updateButtons();
-                        }
-                    })
-                    .build();
+                .closeOnEsc(0)
+                .closeOnClickOut(0)
+                .withLabel("gui.create_world.label.select_world_type")
+                .withList("worldTypeList", 140, keys, descs, WorldTypeGroups.GROUPS.indexOf(worldTypeGroup), true)
+                .withOnCloseListener((statusCode, results) -> {
+                    if (statusCode == 1) {
+                        worldTypeGroup = WorldTypeGroups.GROUPS.get((Integer) results.get("worldTypeList"));
+                        updateButtons();
+                    }
+                })
+                .build();
             mc.displayGuiScreen(popup);
-        }
-        else if (button == buttonRandomWorldName)
-        {
+        } else if (button == buttonRandomWorldName) {
             textboxWorldName.setText(I18n.getInstance().getCurrentLanguage().getRandomWorldName());
             updateFolderName();
-        }
-        else if (button == buttonRandomSeed)
-        {
+        } else if (button == buttonRandomSeed) {
             this.seed = (new Random()).nextLong();
             textboxSeed.setPlaceholder(Long.toString(seed));
             textboxSeed.setText("");
@@ -239,38 +184,32 @@ public class GuiCreateWorld extends GuiScreen
         I18n i18n = I18n.getInstance();
         gamemodeButton.displayString = i18n.translateKeyAndFormat("gui.create_world.button.gamemode", i18n.translateNameKey(selectedGamemode.getLanguageKey()));
         cheatsButton.displayString = i18n.translateKeyAndFormat("gui.create_world.button.cheats", i18n.translateKey(cheatsEnabled ? "gui.create_world.button.cheats.on" : "gui.create_world.button.cheats.off"));
-        worldTypeButton.displayString = i18n.translateKeyAndFormat("gui.create_world.button.world_type", i18n.translateNameKey(worldTypes.get(worldType).getLanguageKey()));
+        worldTypeButton.displayString = i18n.translateKeyAndFormat("gui.create_world.button.world_type", i18n.translateNameKey(worldTypeGroup.get(Dimension.overworld).getLanguageKey()));
     }
 
     @Override
-	public void keyTyped(char c, int i, int mouseX, int mouseY)
-    {
-    	if(i != Keyboard.KEY_BACK) super.keyTyped(c, i, mouseX, mouseY);
-        if(textboxWorldName.isFocused)
-        {
+    public void keyTyped(char c, int i, int mouseX, int mouseY) {
+        if (i != Keyboard.KEY_BACK) super.keyTyped(c, i, mouseX, mouseY);
+        if (textboxWorldName.isFocused) {
             textboxWorldName.textboxKeyTyped(c, i);
-        } else if (textboxSeed.isFocused)
-        {
+        } else if (textboxSeed.isFocused) {
             textboxSeed.textboxKeyTyped(c, i);
         }
-        if(c == '\r')
-        {
+        if (c == '\r') {
             buttonPressed(controlList.get(0));
         }
         updateFolderName();
     }
 
     @Override
-	public void mouseClicked(int mouseX, int mouseY, int mouseButton)
-    {
+    public void mouseClicked(int mouseX, int mouseY, int mouseButton) {
         super.mouseClicked(mouseX, mouseY, mouseButton);
         textboxWorldName.mouseClicked(mouseX, mouseY, mouseButton);
         textboxSeed.mouseClicked(mouseX, mouseY, mouseButton);
     }
 
     @Override
-	public void drawScreen(int mouseX, int mouseY, float partialTick)
-    {
+    public void drawScreen(int mouseX, int mouseY, float partialTick) {
         I18n stringtranslate = I18n.getInstance();
         drawDefaultBackground();
         drawStringCentered(fontRenderer, stringtranslate.translateKey("gui.create_world.label.title"), width / 2, 20, 0xffffff);
@@ -282,21 +221,17 @@ public class GuiCreateWorld extends GuiScreen
     }
 
     @Override
-	public void selectNextField()
-    {
-        if(textboxWorldName.isFocused)
-        {
+    public void selectNextField() {
+        if (textboxWorldName.isFocused) {
             textboxWorldName.setFocused(false);
             textboxSeed.setFocused(true);
-        } else
-        {
+        } else {
             textboxWorldName.setFocused(true);
             textboxSeed.setFocused(false);
         }
     }
 
-    public void runPreset(String name, String seed, int spawnX, int spawnY, int spawnZ)
-    {
+    public void runPreset(String name, String seed, int spawnX, int spawnY, int spawnZ) {
         overrideSpawnX = spawnX;
         overrideSpawnY = spawnY;
         overrideSpawnZ = spawnZ;
diff --git a/src/main/java/net/minecraft/client/gui/GuiCredits.java b/src/main/java/net/minecraft/client/gui/GuiCredits.java
new file mode 100644
index 000000000..1dc580ded
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/GuiCredits.java
@@ -0,0 +1,269 @@
+package net.minecraft.client.gui;
+
+import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
+import net.minecraft.client.render.Scissor;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.core.util.helper.MathHelper;
+import org.lwjgl.input.Keyboard;
+import org.lwjgl.input.Mouse;
+import org.lwjgl.opengl.GL11;
+
+import java.awt.*;
+import java.io.BufferedReader;
+import java.io.InputStream;
+import java.io.InputStreamReader;
+import java.nio.charset.StandardCharsets;
+import java.util.ArrayList;
+import java.util.List;
+
+import static org.lwjgl.opengl.GL11.*;
+
+public class GuiCredits extends GuiScreen {
+    private static final int TOP_SPACING = 24;
+    private static final int BUTTON_SPACING = 4;
+
+    private static final String[] SONGS = {
+        "cat",
+        "blocks",
+        "chirp",
+        "far",
+        "mall",
+        "mellohi",
+        "stal",
+        "strad",
+        "ward",
+        "dog",
+    };
+
+    protected int top;
+    protected int bottom;
+
+    private float scrollAmount = 0.0f;
+    private Float oldScrollAmount;
+    private int scrollRegionHeight;
+    private Integer clickX, clickY;
+
+    private boolean playing = false;
+
+    private List<String> lines;
+
+    private float hue = 0;
+
+    public GuiCredits(GuiScreen parent) {
+        super(parent);
+
+        try (InputStream stream = GuiMainMenu.class.getResourceAsStream("/credits.txt")) {
+
+            List<String> lines = new ArrayList<>();
+            BufferedReader br = new BufferedReader(new InputStreamReader(stream, StandardCharsets.UTF_8));
+
+            while (true) {
+                String line = br.readLine();
+                if (line == null) {
+                    break;
+                }
+                line = line.trim();
+                lines.add(line);
+            }
+            this.lines = lines;
+        } catch (Exception e) {
+            e.printStackTrace();
+            this.lines = new ArrayList<>();
+            this.lines.add("An error occurred while loading the credits.");
+        }
+    }
+
+    @Override
+    public void init() {
+        top = TOP_SPACING;
+        bottom = height - (BUTTON_SPACING + 20 + BUTTON_SPACING);
+        scrollRegionHeight = bottom - top;
+        add(new GuiListenerButton(0, width / 2 - 100, height - (BUTTON_SPACING + 20), 200, 20, I18n.getInstance().translateKey("gui.credits.button.done")).setActionListener(() -> {
+            onClosed();
+            mc.displayGuiScreen(null);
+        }));
+
+        onScroll();
+    }
+
+    @Override
+    public void tick() {
+        if (!playing) {
+            mc.sndManager.playStreaming(SONGS[(int) (Math.random() * SONGS.length)], 0, 0, 0, 1.0f, 1.0f);
+            playing = true;
+        }
+    }
+
+    @Override
+    public void onClosed() {
+        mc.sndManager.playStreaming(null, 0, 0, 0, 0, 0);
+    }
+
+    @Override
+    public void drawScreen(int mouseX, int mouseY, float partialTick) {
+        // Handle scrolling
+        if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
+            scroll(Mouse.getDWheel() * -0.01f);
+        } else {
+            scroll(Mouse.getDWheel() / -0.05f);
+        }
+
+        drawDefaultBackground();
+        overlayBackground(0, width, 0, top);
+        overlayBackground(0, width, bottom, height);
+
+        drawScrollBar(mouseX, mouseY);
+
+        super.drawScreen(mouseX, mouseY, partialTick);
+
+        fontRenderer.drawCenteredString(I18n.getInstance().translateKey("gui.credits.label.title"), width / 2, 5, 0xFFFFFF);
+
+        Scissor.enable(0, top, width, bottom - top);
+        drawContent();
+        Scissor.disable();
+
+        hue = (hue + 1) % 360f;
+    }
+
+    private void drawContent() {
+        mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/title/mclogo.png").bind();
+        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        drawTexturedModalRect(width / 2 - 274 / 2, 30 - (int)scrollAmount, 0, 0, 274, 50, 1d/274, 1d/50);
+
+        for (int i = 0; i < lines.size(); i++) {
+            String line = lines.get(i);
+            if (line.startsWith("*")) {
+                line = TextFormatting.BOLD + line.substring(1);
+                int lineWidth = fontRenderer.getStringWidth(line) + line.length();
+                fontRenderer.drawString(line, width / 2 - lineWidth / 2, 100 + i * 12 - (int)scrollAmount, 0xFFFFFF);
+            } else if (line.startsWith("!")) {
+                int rgb = Color.HSBtoRGB(hue / 360f, 1.0f, 1.0f);
+                line = TextFormatting.BOLD + line.substring(1);
+                int lineWidth = fontRenderer.getStringWidth(line) + line.length();
+                fontRenderer.drawString(line, width / 2 - lineWidth / 2, 100 + i * 12 - (int)scrollAmount, rgb);
+            } else {
+                fontRenderer.drawString(line, width / 2 - fontRenderer.getStringWidth(line) / 2, 100 + i * 12 - (int) scrollAmount, 0x7F7F7F);
+            }
+        }
+    }
+
+    protected void drawScrollBar(int mouseX, int mouseY) {
+        float totalPageHeight = getTotalPageHeight();
+        float scrollBarHeightPercent = scrollRegionHeight / totalPageHeight;
+
+        if (scrollBarHeightPercent > 1.0f) return;
+
+        glDisable(GL_TEXTURE_2D);
+
+        int scrollBarX = width - 6;
+
+        int scrollBarHeightPx = (int) (scrollBarHeightPercent * scrollRegionHeight);
+        if (scrollBarHeightPx < 32) {
+            scrollBarHeightPx = 32;
+        }
+
+        float scrollPercent = scrollAmount / (totalPageHeight - scrollRegionHeight);
+
+        int scrollBarY = (int) (top + (scrollRegionHeight - scrollBarHeightPx) * scrollPercent);
+
+        Tessellator t = Tessellator.instance;
+
+        t.startDrawingQuads();
+        t.setColorOpaque(0, 0, 0);
+        t.drawRectangle(scrollBarX, top, 6, scrollRegionHeight);
+        t.setColorRGBA_I(0x808080, 255);
+        t.drawRectangle(scrollBarX, scrollBarY, 6, scrollBarHeightPx);
+        t.setColorRGBA_I(0xc0c0c0, 255);
+        t.drawRectangle(scrollBarX + 1, scrollBarY, 5, scrollBarHeightPx - 1);
+        t.draw();
+
+        glEnable(GL_TEXTURE_2D);
+
+        if (clickX != null && clickY != null) {
+            if (clickX >= scrollBarX && clickY >= top && clickX <= scrollBarX + 6 && clickY < bottom) {
+                if (oldScrollAmount == null) {
+                    oldScrollAmount = scrollAmount;
+                }
+                scrollAmount = oldScrollAmount + (clickY - mouseY) * (1.0f / scrollBarHeightPercent) * -1.0f;
+                onScroll();
+            }
+        } else {
+            oldScrollAmount = null;
+        }
+    }
+
+    @Override
+    public void mouseClicked(int mouseX, int mouseY, int mouseButton) {
+        super.mouseClicked(mouseX, mouseY, mouseButton);
+
+        clickX = mouseX;
+        clickY = mouseY;
+    }
+
+    @Override
+    public void drawDefaultBackground() {
+        super.drawDefaultBackground();
+
+        Tessellator tessellator = Tessellator.instance;
+        mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+        float scale = 32F;
+        tessellator.startDrawingQuads();
+        tessellator.setColorOpaque_I(0x202020);
+
+        tessellator.addVertexWithUV(0, bottom, 0.0D, 0, (float) (bottom + (int) scrollAmount) / scale);
+        tessellator.addVertexWithUV(width, bottom, 0.0D, (float) width / scale, (float) (bottom + (int) scrollAmount) / scale);
+        tessellator.addVertexWithUV(width, top, 0.0D, (float) width / scale, (float) (top + (int) scrollAmount) / scale);
+        tessellator.addVertexWithUV(0, top, 0.0D, 0, (float) (top + (int) scrollAmount) / scale);
+
+        tessellator.draw();
+    }
+
+    private void overlayBackground(int minX, int maxX, int minY, int maxY) {
+        if (mc.theWorld == null) {
+            Tessellator tessellator = Tessellator.instance;
+            mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+            float scale = 32F;
+            tessellator.startDrawingQuads();
+            tessellator.setColorOpaque_I(0x404040);
+            tessellator.addVertexWithUV(minX, maxY, 0.0D, (float) minX / scale, (float) maxY / scale);
+            tessellator.addVertexWithUV(maxX, maxY, 0.0D, (float) maxX / scale, (float) maxY / scale);
+            tessellator.setColorOpaque_I(0x404040);
+            tessellator.addVertexWithUV(maxX, minY, 0.0D, (float) maxX / scale, (float) minY / scale);
+            tessellator.addVertexWithUV(minX, minY, 0.0D, (float) minX / scale, (float) minY / scale);
+            tessellator.draw();
+        }
+    }
+
+
+    private void scroll(float amount) {
+        if (amount == 0.0f) return;
+
+        scrollAmount += amount;
+        onScroll();
+    }
+
+    private void onScroll() {
+        int totalPageHeight = getTotalPageHeight();
+        if (scrollAmount < 0 || scrollRegionHeight > totalPageHeight) scrollAmount = 0;
+        else if (scrollAmount > totalPageHeight - scrollRegionHeight)
+            scrollAmount = totalPageHeight - scrollRegionHeight;
+    }
+
+    private int getTotalPageHeight() {
+        return 100 + lines.size() * 12;
+    }
+
+    @Override
+    public void mouseMovedOrButtonReleased(int mouseX, int mouseY, int mouseButton) {
+        super.mouseMovedOrButtonReleased(mouseX, mouseY, mouseButton);
+
+        if (mouseButton >= 0) {
+            clickX = null;
+            clickY = null;
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/GuiDispenser.java b/src/main/java/net/minecraft/client/gui/GuiDispenser.java
index 568b8fdf6..2bf5a9913 100644
--- a/src/main/java/net/minecraft/client/gui/GuiDispenser.java
+++ b/src/main/java/net/minecraft/client/gui/GuiDispenser.java
@@ -1,21 +1,21 @@
 package net.minecraft.client.gui;
 
+import net.minecraft.core.block.entity.DispenserBlockEntity;
 import net.minecraft.core.lang.I18n;
-import net.minecraft.core.player.inventory.ContainerDispenser;
-import net.minecraft.core.player.inventory.InventoryPlayer;
-import net.minecraft.core.block.entity.TileEntityDispenser;
+import net.minecraft.core.player.inventory.menu.TrapMenu;
+import net.minecraft.core.player.inventory.container.Inventory;
 import org.lwjgl.opengl.GL11;
 
 // Referenced classes of package net.minecraft.src:
 //            GuiContainer, ContainerDispenser, FontRenderer, RenderEngine, 
-//            InventoryPlayer, TileEntityDispenser
+//            InventoryPlayer, DispenserBlockEntity
 
 public class GuiDispenser extends GuiContainer
 {
 
-    public GuiDispenser(InventoryPlayer inventoryplayer, TileEntityDispenser tileentitydispenser)
+    public GuiDispenser(Inventory inventoryplayer, DispenserBlockEntity tileentitydispenser)
     {
-        super(new ContainerDispenser(inventoryplayer, tileentitydispenser));
+        super(new TrapMenu(inventoryplayer, tileentitydispenser));
     }
 
     @Override
@@ -28,9 +28,8 @@ public class GuiDispenser extends GuiContainer
     @Override
 	protected void drawGuiContainerBackgroundLayer(float f)
     {
-        int i = mc.renderEngine.getTexture("/assets/minecraft/textures/gui/trap.png");
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        mc.renderEngine.bindTexture(i);
+        mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/container/dispenser.png").bind();
         int j = (width - xSize) / 2;
         int k = (height - ySize) / 2;
         drawTexturedModalRect(j, k, 0, 0, xSize, ySize);
diff --git a/src/main/java/net/minecraft/client/gui/GuiDownloadTerrain.java b/src/main/java/net/minecraft/client/gui/GuiDownloadTerrain.java
index b1b46a8ad..4ee1d3c2d 100644
--- a/src/main/java/net/minecraft/client/gui/GuiDownloadTerrain.java
+++ b/src/main/java/net/minecraft/client/gui/GuiDownloadTerrain.java
@@ -1,17 +1,17 @@
 package net.minecraft.client.gui;
 
 // Referenced classes of package net.minecraft.src:
-//            GuiScreen, Packet0KeepAlive, NetClientHandler, StringTranslate, 
+//            GuiScreen, KeepAlivePacket, ClientPacketHandler, StringTranslate,
 //            GuiButton
 
-import net.minecraft.client.net.handler.NetClientHandler;
-import net.minecraft.core.net.packet.Packet0KeepAlive;
+import net.minecraft.client.net.handler.ClientPacketHandler;
+import net.minecraft.core.net.packet.KeepAlivePacket;
 import net.minecraft.core.lang.I18n;
 
 public class GuiDownloadTerrain extends GuiScreen
 {
 
-    public GuiDownloadTerrain(NetClientHandler netclienthandler)
+    public GuiDownloadTerrain(ClientPacketHandler netclienthandler)
     {
         updateCounter = 0;
         netHandler = netclienthandler;
@@ -34,11 +34,11 @@ public class GuiDownloadTerrain extends GuiScreen
         updateCounter++;
         if(updateCounter % 20 == 0)
         {
-            netHandler.addToSendQueue(new Packet0KeepAlive());
+            netHandler.addToSendQueue(new KeepAlivePacket());
         }
         if(netHandler != null)
         {
-            netHandler.processReadPackets();
+            netHandler.tick();
         }
     }
 
@@ -57,6 +57,6 @@ public class GuiDownloadTerrain extends GuiScreen
         super.drawScreen(mouseX, mouseY, partialTick);
     }
 
-    private NetClientHandler netHandler;
+    private ClientPacketHandler netHandler;
     private int updateCounter;
 }
